#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/twi.h>

#ifndef F_CPU
    #error "need to define cpu frequency first."
#endif

//------------------------------------------------------------------------------
namespace mc {

//------------------------------------------------------------------------------
constexpr const uint32_t cpu_frequency = F_CPU;

//------------------------------------------------------------------------------
using count_t = uint8_t;

using word_t                           = detail::cpu_conf::word_t;
using dword_t                          = detail::cpu_conf::dword_t;
constexpr const auto dword_half_offset = detail::cpu_conf::dword_half_offset;
constexpr const auto dword_half_cut    = detail::cpu_conf::dword_half_cut;

//------------------------------------------------------------------------------
enum class pin_register_kind { direction, port, pin };

//------------------------------------------------------------------------------
} // namespace mc

namespace mc { namespace detail {

#include "register.inc.hpp"
#include "pin.inc.hpp"
#include "irq.inc.hpp"
#include "timer.inc.hpp"
#include "uart.inc.hpp"
#include "twi.inc.hpp"
#include "spi.inc.hpp"
#include "adc.inc.hpp"

//------------------------------------------------------------------------------
}} // namespace mc::detail
