//------------------------------------------------------------------------------
// BASIC REGISTERSET
//------------------------------------------------------------------------------
struct basic_register_set {
    DEFINE_VALUE_ENUM(id_t, count_t)
    using ptr_t = volatile word_t*;
    
    template<const id_t& Reg>
    constexpr static ptr_t ptr() { return reinterpret_cast<ptr_t>(*Reg); }
    
    template<const id_t& Reg>
    inline static void write(word_t value) { *ptr<Reg>() = value; }
    
    template<const id_t& Reg>
    inline static word_t read() { return *ptr<Reg>(); }

    template<const id_t& Reg, count_t Pos>
    inline static void set() { *ptr<Reg>() |= (1 << Pos); }

    template<const id_t& Reg, count_t Pos>
    inline static void clr() { *ptr<Reg>() &= ~(1 << Pos); }

    template<const id_t& Reg, count_t Pos>
    inline static bool get() { return *ptr<Reg>() & (1 << Pos); }
};
