#pragma once

//------------------------------------------------------------------------------
namespace mc {

template<class T>
struct value_enum {
    constexpr value_enum(const T& v): value(v) {}

    constexpr const T& operator*() const { return value; }
    T value;
};

//------------------------------------------------------------------------------
#define DEFINE_VALUE_ENUM(NAME, INNERTYPE)                                     \
    struct NAME : public mc::value_enum<INNERTYPE>                             \
    { using value_enum::value_enum; };

//------------------------------------------------------------------------------
} // namespace mc
