#pragma once

//------------------------------------------------------------------------------
namespace mc {

template<class T, count_t N>
struct array {
    using value_t = T;
    using count_t = mc::count_t;

    array() {}

    template<class... Ts>
    array(Ts... ds)
    : data_{ds...} 
    {}

    array(const array<T,N>& o) {
        for (count_t i = 0; i < N; ++i) {
            data_[N] = o[N];
        }
    };

    inline       T* begin()       { return &data_[0]; }
    inline       T* end  ()       { return &data_[N]; }
    inline const T* begin() const { return &data_[0]; }
    inline const T* end  () const { return &data_[N]; }

          T& operator[](count_t pos)       { return data_[pos]; }
    const T& operator[](count_t pos) const { return data_[pos]; }

    constexpr inline count_t size() const { return N; }

    T data_[N];
};

//------------------------------------------------------------------------------
} // namespace mc
