#pragma once

namespace mc { namespace util { namespace adc {

//------------------------------------------------------------------------------
// ADC
//------------------------------------------------------------------------------
template<
    const device::adc::reference::id_t& Ref = *device::adc::defaults::reference,
    const device::adc::prescaler::id_t& PS = *device::adc::defaults::prescaler>
inline void use() {
    device::adc::set_reference<Ref>();
    device::adc::set_prescaler<PS>();
    device::adc::enable();
}

//------------------------------------------------------------------------------
template<class Res = device::adc::defaults::resolution>
inline typename Res::type read() {
    return device::adc::read<Res>();
}

//------------------------------------------------------------------------------
template<const device::pin::id_t& Pin,
         class Res = device::adc::defaults::resolution>
inline void start_async() {
    device::adc::set_resolution<Res>();
    device::adc::select_channel<Pin>();
    device::adc::start();
}

//------------------------------------------------------------------------------
template<const device::pin::id_t& Pin,
         class Res = device::adc::defaults::resolution>
typename Res::type measure() {
    start_async<Pin, Res>();
    while(device::adc::conversion_running());
    return read<Res>();
}

//------------------------------------------------------------------------------
}}} // namespace mc::util
