#pragma once

namespace mc { namespace util { namespace irq {
//------------------------------------------------------------------------------
// IRQ
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
template<const device::irq::id_t& Irq>
inline void use(device::irq::isr_t isr) {
    device::irq::attach<Irq>(isr);
    device::irq::enable<Irq>();
}

//------------------------------------------------------------------------------
template<const device::irq::id_t& Irq,
         const device::irq::trigger::id_t& Trigger=device::irq::trigger::rising>
inline void use_external(device::irq::isr_t isr) {
    device::irq::set_trigger<Irq,Trigger>();
    use<Irq>(isr);
}

//------------------------------------------------------------------------------
}}} // namespace mc::util::irq
