#pragma once

namespace mc { namespace util { namespace timer {

//------------------------------------------------------------------------------
// TIMER
//------------------------------------------------------------------------------
template<class                                 Timer,
         const pin::id_t&                      Pin,
         const typename Timer::clock::id_t&    Clk =*Timer::defaults::pwm::Clk,
         const typename Timer::waveform::id_t& Wave=*Timer::defaults::pwm::Wave,
         const typename Timer::pwm::id_t&      Mode=*Timer::defaults::pwm::Mode>
inline void use_pwm() {
    Timer::template set_clock<Clk>();
    Timer::template set_waveform<Wave>();
    Timer::template set_pwm_mode<Pin,Mode>();
}

//------------------------------------------------------------------------------
}}} // namespace mc::util::timer
