#pragma once

namespace mc { namespace util { namespace uart {

//------------------------------------------------------------------------------
// UART
//------------------------------------------------------------------------------
template<
    class Uart = device::defaults::uart,
    const typename Uart::baud::baud_t Baud = Uart::defaults::baud_rate,
    const typename Uart::control::mode::id_t& Mode = *Uart::defaults::mode,
    const bool Recv = Uart::defaults::recv,
    const bool Transmit = Uart::defaults::transmit,
    const typename Uart::character_size::id_t& Cs = *Uart::defaults::cs>
inline void use() {
    Uart::template set_baud_rate<Baud>();
    Uart::template set_mode<Mode>();
    Uart::template set_character_size<Cs>();
    Uart::set_recv(Recv);
    Uart::set_transmit(Transmit);
}

//------------------------------------------------------------------------------
}}} // namespace mc::util
