#pragma once
#include <util/delay.h>

namespace mc { namespace util {
//------------------------------------------------------------------------------
// DELAY, WAIT
//  -> use delay() for short periods (0..255 ms)
//  -> and wait() for longer periods

template<count_t Ms>
inline void delay() { _delay_ms(Ms); }

template<count_t Step = 10>
inline void wait(uint16_t ms) {
    for (uint16_t i = 0; i < ms; i += Step) {
        delay<Step>();
    }
}

//------------------------------------------------------------------------------
}} // namespace mc::util
